searchNodes=[{"ref":"BtrzWebhooksEmitter.html","title":"BtrzWebhooksEmitter","type":"module","doc":"BtrzWebhooksEmitter emits webhooks to SQS for the Betterez platform. This module has the API to send messages asynchrounously to the BtrzWebhooksEmitter.SQS. You will have to set these ENV vars: AWS_SERVICE_KEY AWS_SERVICE_SECRET SQS_QUEUE_URL You can set SQS_QUEUE_URL in your config: config :btrz_ex_webhooks_emitter, queue_url: &quot;id/name&quot; If one of them is missing the messages will be ignored. How to use You have to send a map with the following required (string) keys: &quot;provider_id&quot; &quot;api_key&quot; &quot;data&quot; Optional keys: &quot;url&quot; message = %{ &quot;provider_id&quot; =&gt; &quot;123&quot;, &quot;api_key&quot; =&gt; &quot;PROVIDER_PUBLIC_KEY&quot;, &quot;data&quot; =&gt; %{&quot;foo&quot; =&gt; &quot;bar&quot;} } BtrzWebhooksEmitter.emit(&quot;transaction.created&quot;, message)"},{"ref":"BtrzWebhooksEmitter.html#build_message/2","title":"BtrzWebhooksEmitter.build_message/2","type":"function","doc":"Returns the message map."},{"ref":"BtrzWebhooksEmitter.html#emit/2","title":"BtrzWebhooksEmitter.emit/2","type":"function","doc":"Builds and sends messages asynchrounously to the BtrzWebhooksEmitter.SQS If there is a validation error in your attrs it will return :error and log the error, otherwise always :ok."},{"ref":"BtrzWebhooksEmitter.html#emit_sync/2","title":"BtrzWebhooksEmitter.emit_sync/2","type":"function","doc":"Builds and sends messages synchrounously to the BtrzWebhooksEmitter.SQS For particular use, try always to use emit/2 if possible. Returns {:ok, term} or {:error, term}"},{"ref":"BtrzWebhooksEmitter.Application.html","title":"BtrzWebhooksEmitter.Application","type":"module","doc":"Application callback to start the service."},{"ref":"BtrzWebhooksEmitter.Application.html#start/2","title":"BtrzWebhooksEmitter.Application.start/2","type":"function","doc":"Starts the BtrzWebhooksEmitter."},{"ref":"BtrzWebhooksEmitter.SQS.html","title":"BtrzWebhooksEmitter.SQS","type":"module","doc":"Genserver for emitting events to the configured AWS SQS If there is no SQS_QUEUE_URL, the GenServer will be started with :ignore and the process will exit normally."},{"ref":"BtrzWebhooksEmitter.SQS.html#child_spec/1","title":"BtrzWebhooksEmitter.SQS.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"BtrzWebhooksEmitter.SQS.html#emit/2","title":"BtrzWebhooksEmitter.SQS.emit/2","type":"function","doc":"Emits messages asynchrounously Returns always :ok"},{"ref":"BtrzWebhooksEmitter.SQS.html#emit_sync/2","title":"BtrzWebhooksEmitter.SQS.emit_sync/2","type":"function","doc":"Emits messages synchrounously For particular use, try always to use emit/1 if possible. Returns emit_sync_response :: {:ok, term} | {:error, term}"},{"ref":"BtrzWebhooksEmitter.SQS.html#handle_call/3","title":"BtrzWebhooksEmitter.SQS.handle_call/3","type":"function","doc":"Sends sync the message to AWS SQS and returns {:ok, result}. If something fails, it will log the error and returns {:error, reason}"},{"ref":"BtrzWebhooksEmitter.SQS.html#handle_cast/2","title":"BtrzWebhooksEmitter.SQS.handle_cast/2","type":"function","doc":"Sends async the message to AWS SQS. If something fails, it will just log the error."},{"ref":"BtrzWebhooksEmitter.SQS.html#init/1","title":"BtrzWebhooksEmitter.SQS.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"BtrzWebhooksEmitter.SQS.html#start_link/2","title":"BtrzWebhooksEmitter.SQS.start_link/2","type":"function","doc":"Starts a new BtrzWebhooksEmitter process."},{"ref":"BtrzWebhooksEmitter.SQS.html#t:emit_sync_response/0","title":"BtrzWebhooksEmitter.SQS.emit_sync_response/0","type":"type","doc":"Response for every function"},{"ref":"readme.html","title":"BtrzWebhooksEmitter","type":"extras","doc":"BtrzWebhooksEmitter Betterez elixir client for emitting webhooks to the SQS queue."},{"ref":"readme.html#documentation","title":"BtrzWebhooksEmitter - Documentation","type":"extras","doc":"API documentation at HexDocs https://hexdocs.pm/btrz_ex_webhooks_emitter"},{"ref":"readme.html#installation","title":"BtrzWebhooksEmitter - Installation","type":"extras","doc":"def deps do [{:btrz_ex_webhooks_emitter, &quot;~&gt; 0.2.0&quot;}] end"},{"ref":"readme.html#configuration","title":"BtrzWebhooksEmitter - Configuration","type":"extras","doc":"This lib will use the following ENV variables: AWS_ACCESS_KEY_ID AWS_SECRET_ACCESS_KEY SQS_QUEUE_URL (or by config) Or you can set SQS_QUEUE_URL in your config: config :btrz_ex_webhooks_emitter, queue_url: &quot;id/name&quot;"},{"ref":"readme.html#how-to-use","title":"BtrzWebhooksEmitter - How to use","type":"extras","doc":"message = %{ &quot;provider_id&quot; =&gt; &quot;123&quot;, &quot;api_key&quot; =&gt; &quot;PROVIDER_PUBLIC_KEY&quot;, &quot;data&quot; =&gt; %{&quot;foo&quot; =&gt; &quot;bar&quot;} } BtrzWebhooksEmitter.emit(&quot;transaction.created&quot;, message) BtrzWebhooksEmitter.emit/2 will send asynchronously a message to SQS always responding :ok, it will log an error if exists."},{"ref":"readme.html#synchronous-mode","title":"BtrzWebhooksEmitter - Synchronous mode","type":"extras","doc":"You might want to use BtrzWebhooksEmitter.emit_sync/2 to send synchronously a message to SQS returning {:ok, result}, or in case of error will log and return {:error, reason}."},{"ref":"readme.html#denied-fields","title":"BtrzWebhooksEmitter - Denied fields","type":"extras","doc":"btrz-webhooks-denied-fields library will be consumed to filter off the possible denied fields."},{"ref":"readme.html#test","title":"BtrzWebhooksEmitter - Test","type":"extras","doc":"AWS_ACCESS_KEY_ID=YOUR_KEY AWS_SERVICE_SECRET=YOUR_SECRET_KEY SQS_QUEUE_URL=YOUR_QUEUE_URL mix test"}]